﻿# -*- coding: UTF-8 -*-
from linux.nginxparser import find_all_in_directives

def get_tags():
    return ['2','2.1','2.1.2']

def run_task(runcontext):
    rc,out=run_audit(runcontext)
    return rc,out
    
def run_audit(runcontext):
    
    ret_code = -1
    ret_msg = ''
    
    curtemplate=runcontext.get_template()
    tmp_vars = {}
    tmp_vars["policyresult"] = "failed"
    tmp_vars["checkresult1"] = "failed"
    tmp_vars["checkvalue1"] = 'nobody'
    runuser = 'nobody'
    cfg_model = runcontext.get_parameter('_nginx_cfg_model')
    tmpusers = find_all_in_directives(cfg_model,'user')
    runcontext.log_debug("tmpusers: %s" % tmpusers)
    if 0 != len(tmpusers):
        runuser = runcontext.replace_inject_characters(tmpusers[-1].value)
        
    tmp_vars["checkvalue1"] = runuser
    if runuser != 'root':
        ret_code = 0
        tmp_vars["policyresult"] = "pass"
        tmp_vars["checkresult1"] = "pass"

    rc,out = curtemplate.render(runcontext.get_template_file('t_2_1_2.j2'),**tmp_vars)
    
    if rc == False:
        ret_code = -2
        ret_msg = ('Failed to render template. %s' % out)
    else:
        ret_msg = out

    return ret_code,ret_msg
