﻿# -*- coding: UTF-8 -*-
import os
import re
import json

def get_tags():
    return ['2','2.1','2.1.4']
    
def run_task(runcontext):
    ansible_params=runcontext.get_mod_params_instance()
    runcontext.set_mod_params_instance(ansible_params,"chdir",None)
    runcontext.set_mod_params_instance(ansible_params,"executable",None)

    module=runcontext.get_module_file("shell.py")
    rc,out=run_audit(runcontext,ansible_params,module)
    return rc,out
    
def run_audit(runcontext,ansible_params,module):
    
    ret_code = 0
    ret_msg = ''
    
    curtemplate=runcontext.get_template()
    nginxbin = runcontext.get_extra_var('NGINX_BIN')
    base_nginxdir = os.path.split(nginxbin)[0].strip()
    base_cfgs = os.path.split(runcontext.get_extra_var('NGINX_CONFIG_FILES'))[0].strip()
    m = re.search("conf",base_cfgs)
    if m != None:
        base_cfgs = base_cfgs[0:m.start()].strip().rstrip(os.sep)
    
    #if base_nginxdir and base_cfgs are same,only find one 
    if base_nginxdir == base_cfgs:
        base_cfgs = ''
    
    tmp_vars = {}
    tmp_vars["policyresult"] = "failed"
    tmp_vars["checkresult1"] = "failed"
    tmp_vars["checkvalue1"] = ''
    tmp_vars["scancommand1"] = "find %s %s -name \"html\" 2>/dev/null" % (runcontext.replace_inject_characters(base_nginxdir),runcontext.replace_inject_characters(base_cfgs))

    runcontext.set_mod_params_instance(ansible_params,"command",tmp_vars["scancommand1"])
    arc1,astdout1,astderr1=runcontext.invoke_module(module,ansible_params)
    runcontext.log_debug_invoke_result(arc1,astdout1,astderr1)
    runcontext.sleep()
    if arc1 != 0:
        return (-2, "Failed to invoke module: %s."%astdout1)

    resultjson1 = json.loads(astdout1)
    astdout1 = resultjson1["stdout"]
    astderr1 = resultjson1["stderr"]
    
    match1_found=re.match("^$",astdout1)
    if match1_found == None:
        ret_code = -1
        tmp_vars["checkvalue1"] = astdout1
    else:
        ret_code = 0
        tmp_vars["policyresult"] = "pass"
        tmp_vars["checkresult1"] = "pass"
        tmp_vars["checkvalue1"] = ""
        
    rc,out = curtemplate.render(runcontext.get_template_file('t_2_1_4.j2'),**tmp_vars)
    
    if rc == False:
        ret_code = -2
        ret_msg = ('Failed to render template. %s' % out)
    else:
        ret_msg = out

    return ret_code,ret_msg
