﻿# -*- coding: UTF-8 -*-
import json
import re


def get_tags():
    return ['2', '2.4', '2.4.1']


def run_task(runcontext):
    ansible_params = runcontext.get_mod_params_instance()
    runcontext.set_mod_params_instance(ansible_params, "chdir", None)
    runcontext.set_mod_params_instance(ansible_params, "executable", None)
    module = runcontext.get_module_file("shell.py")
    rc, out = run_audit(runcontext, ansible_params, module)
    return rc, out


def run_audit(runcontext, ansible_params, module):
    curtemplate = runcontext.get_template()
    allcfgs = runcontext.get_extra_var('ALL_NGINX_CONFIG_FILES')
    nallcfgs = []
    for cfg in allcfgs:
        nallcfgs.append(runcontext.replace_inject_characters(cfg))

    value = []
    tmp_vars = {}
    tmp_vars["policyresult"] = "failed"
    tmp_vars["checkresult1"] = "failed"
    tmp_vars["scancommand1"] = "cat %s 2>/dev/null | egrep \"^\\s*ssi\\s*\"" % " ".join(nallcfgs)
    tmp_vars["systemvalue1"] = ""
    ret_code = 0

    runcontext.set_mod_params_instance(ansible_params, "command", tmp_vars["scancommand1"])
    arc1, astdout1, astderr1 = runcontext.invoke_module(module, ansible_params)
    runcontext.sleep()

    if arc1 != 0:
        return (-2, "Failed to invoke module: %s." % astdout1)
    resultjson1 = json.loads(astdout1)
    astdout1 = resultjson1["stdout"]
    astderr1 = resultjson1["stderr"]
    value.append(astdout1)
    runcontext.log_debug_json(resultjson1)
    match1_found = re.search(r"\s*ssi\s*on;", "".join(value))

    if match1_found:
        ret_code = -1
        tmp_vars["systemvalue1"] = astdout1.strip()
    else:
        ret_code = 0
        tmp_vars["checkresult1"] = "pass"
        tmp_vars["systemvalue1"] = astdout1.strip()

    if tmp_vars["checkresult1"] == "pass":
        tmp_vars["policyresult"] = "pass"

    rc, out = curtemplate.render(runcontext.get_template_file('t_2_4_1.j2'), **tmp_vars)
    if rc == False:
        return (-2, "Failed to render template.%s" % out)

    return ret_code, out
